﻿using jabber.protocol.client;
using PureCloud.ChatBot.Service.Models;

namespace PureCloud.ChatBot.Service.CommandHandlers
{
    public class EchoCommandHandler : ICommandHandler
	{
		#region Private Members
		#endregion Private Members

		#region Public Properties

		public string Command
		{
			get { return "/echo"; }
		}

		public string HelpText
		{
			get { return "Echoes your message."; }
		}

		#endregion Public Properties

		#region Constructors
		public EchoCommandHandler()
		{
		}
		#endregion Constructors

		#region Public Methods
		public CommandResult Handle(Message msg, string inputCmd)
		{
            return new CommandResult
            {
                Output = msg.Body != null ? $"You said: {msg.Body.Substring(Command.Length + 1)}" : null, // Strip the /echo from the returned message
                Tag = Command
            };
		}
		#endregion Public Methods
	}
}
