﻿using PureCloud.ChatBot.Service.CommandHandlers;
using System.Configuration;
using Topshelf;

namespace PureCloud.ChatBot.Service
{
    public static class Program
	{
		private static void Main()
		{
            HostFactory.Run(x =>
				{
					x.Service<JabberService>(s =>
						{
							s.ConstructUsing(name => GetJabberService());
							s.WhenStarted(service => service.Start());
							s.WhenStopped(service => service.Stop());
						});
					x.RunAsLocalSystem();
                });
		}

		public static JabberService GetJabberService()
		{
			string user = ConfigurationManager.AppSettings["User"];
			string server = ConfigurationManager.AppSettings["Server"];
			string password = ConfigurationManager.AppSettings["Password"];
			string networkHost = ConfigurationManager.AppSettings["NetworkHost"];
			string ignoreInvalidCertificateSetting = ConfigurationManager.AppSettings["IgnoreInvalidCertificate"];

            bool ignoreInvalidCertificate = !string.IsNullOrWhiteSpace(ignoreInvalidCertificateSetting) && ignoreInvalidCertificateSetting.ToLower() == "true";

            // Start Jabber
            return new JabberService(user, server, password, networkHost, ignoreInvalidCertificate, GetCommandHandler());
		}

		public static ICommandHandler GetCommandHandler()
		{
            //TODO Register your command handlers here
            var commandHandler = new HelpCommandHandler();
            commandHandler.Register(new EchoCommandHandler());
            commandHandler.Register(new WolframCommandHandler());

			return commandHandler;
		}
	}
}
